Zero-Configuration Assignment of IPv6 Multicast Addresses
Nate Karstens
Garmin International
nate.karstens@gmail.com
Dino Farinacci
lispers.net
farinacci@gmail.com
Mike McBride
Futurewei
michael.mcbride@futurewei.com
23 July 2024
Describes a zero-configuration protocol for dynamically assigning IPv6 multicast addresses. Applications randomly assign multicast group IDs from a reserved range and prevent collisions by using mDNS to publish records in a new "eth-addr.arpa" special-use domain. This protocol satisfies all of the criteria listed in draft-ietf-pim-zeroconf-mcast-addr-alloc-ps.

Introduction
[I-D.ietf-pim-zeroconf-mcast-addr-alloc-ps] includes a problem statement and requirements for a zero-configuration method for dynamically assigning multicast addresses. This document describes a process that fulfills these requirements by having applications randomly assign IPv6 multicast group IDs from a reserved range and using mDNS to prevent collisions.
Once the IPv6 multicast address has been assigned, the data contained the multicast stream may be advertised using the method described in [I-D.karstens-dnssd-dns-msd].
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Procedure
When an application is preparing to transmit a multicast stream, it first generates a random group ID in the range 0x90000000-0x9FFFFFFF, which IANA should reserve from the "Dynamic Multicast Group IDs" registry (see Section 4). It combines this with the Interface Identifier (IID) of the intended source address for the multicast stream to generate a link-scoped IPv6 multicast address [RFC4489]. The application then calculates the multicast Ethernet address that will be used to transmit the data ([RFC2464], Section 7) and uses that to construct a string like a reverse-mapping domain, using a new "eth-addr.arpa" special-use domain.
For example, given a source address of fe80::a12:34ff:fe56:7890, the IPv6 multicast address may be ff32:00ff:a12:34ff:fe56:7890:9abc:def0, the multicast Ethernet address 33:33:9A:BC:DE:F0, and the resulting string is "0.f.e.d.c.b.a.9.3.3.3.3.eth-addr.arpa".
The application then uses the mDNS probing algorithm described in [RFC6762], Section 8.1 to continuously query for a PTR record with the same name as the generated string. If the probing algorithm completes without any conflict, then the application begins advertising its own unique PTR record using that name. The PTRDNAME field consists of a unique application identifier, in the form of a DNS label, followed by the device's host name (for example, "application.example.local."). Integrating a unique identifier in this manner allows for multiple applications to be on the same host.
Once the PTR record is advertised, the host may then begin transmitting multicast data using the generated address.
The application shall retain the group ID value and use it the next time the multicast stream is transmitted. This allows the network to quickly settle on a configuration that will never have another collision as long as the network is unchanged.
If a conflict is detected at any point, then the application stops transmitting that multicast stream and starts the process over using a different group ID.
The host may optionally monitor the bus for traffic that uses the same destination multicast Ethernet address, but a different destination multicast IPv6 address. If this is detected, then the application responds the same as a collision.
While intended primarily for allocating IPv6 multicast addresses on the same subnet (link-local scope), the same technique could also apply to a larger network as long as mDNS traffic is routed between subnets (for any scope excluding global scope).

Veto Records
[I-D.ietf-pim-zeroconf-mcast-addr-alloc-ps] describes collisions occurring in the network infrastructure. When an infrastructure component detects a collision it cannot resolve, it triggers a conflict with the application by publishing a veto record. A veto record is a unique PTR record using the string generated for the address as its name and the PTRDNAME field set to the string "veto", formatted as a DNS label. The veto record is published without probing.
Applications respond to the conflict the same as to a collision. The application retains its new group ID, so the same conflict is not repeated in the future.

Evaluation of Solution
[I-D.ietf-pim-zeroconf-mcast-addr-alloc-ps] contains a list of criteria to evaluate potential solutions. The protocol described in this document satisfies all of the required criteria.
However, because mDNS is designed to be a low-bandwidth protocol, it can take a signficant amount of time to detect a record collision after a network partition is repaired. This is not a concern on networks where all multicast streams are established before any likely partition event because all group IDs will have been selected and stored for future use.
It is a greater concern on networks where multicast streams may be established at any time. Deployments on these networks may consider engaging a detection mechanism and prompting hosts to send unsolicited mDNS response messages when the partition is repaired.
The protocol described in this document also satisfies the recommended criteria, to the extent that a deployment supports publishing mDNS-based DNS-SD records across multiple subnets (see [RFC8766]).

IANA Considerations
IANA should allocate a block of group IDs from the "Dynamic Multicast Group IDs" registry in the "IPv6 Multicast Address Space Registry" registry group that was created by [I-D.ietf-pim-updt-ipv6-dyn-mcast-addr-grp-id]. The range of this block should be 0x90000000-0x9FFFFFFF and the description should be the title of this document.
The special-use domain "eth-addr.arpa" should be registered in the .arpa registry (https://www.iana.org/domains/arpa) and the "Special-Use Domain Names" registry (https://www.iana.org/assignments/special-use-domain-names). This domain should not be delegated.

Domain Name Reservation Considerations
The "eth-addr.arpa." domain is effectively a reverse-mapping domain and so has the same considerations as the reverse-mapping domains listed in [RFC6761], Section 6.1.

Security Considerations
This algorithm only works in environments where all hosts are cooperating. Malicious hosts could deny service by either repeatedly responding to queries for a given address or by flooding the network with traffic.

Acknowledgement
Special thanks to the National Marine Electronics Association for their contributions in developing marine industry standards and their support for this research.
Thanks also to the members of the PIM working group for their early brainstorming sessions and review of this draft.

Normative References

Informative References
[I-D.ietf-pim-zeroconf-mcast-addr-alloc-ps]
[I-D.karstens-dnssd-dns-msd]
[RFC2119]
[RFC8174]
[RFC4489]
[RFC2464]
[RFC6762]
[RFC8766]
[I-D.ietf-pim-updt-ipv6-dyn-mcast-addr-grp-id]
[RFC6761]